Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
        Friend WithEvents txtContents As System.Windows.Forms.TextBox
    Friend WithEvents btnCreateXml As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtContents = New System.Windows.Forms.TextBox()
        Me.btnCreateXml = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'txtContents
        '
        Me.txtContents.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtContents.Font = New System.Drawing.Font("Courier New", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtContents.Location = New System.Drawing.Point(0, 40)
        Me.txtContents.Multiline = True
        Me.txtContents.Name = "txtContents"
        Me.txtContents.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtContents.Size = New System.Drawing.Size(584, 405)
        Me.txtContents.TabIndex = 1
        Me.txtContents.Text = ""
        '
        'btnCreateXml
        '
        Me.btnCreateXml.Anchor = System.Windows.Forms.AnchorStyles.None
        Me.btnCreateXml.Location = New System.Drawing.Point(248, 8)
        Me.btnCreateXml.Name = "btnCreateXml"
        Me.btnCreateXml.Size = New System.Drawing.Size(80, 23)
        Me.btnCreateXml.TabIndex = 0
        Me.btnCreateXml.Text = "Create XML"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(584, 445)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtContents, Me.btnCreateXml})
        Me.Name = "Form1"
        Me.Text = "BuildDocument"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        btnCreateXml.SetBounds( _
            (ClientSize.Width - btnCreateXml.Size.Width) / 2, _
            btnCreateXml.Location.Y, _
            btnCreateXml.Size.Width, _
            btnCreateXml.Size.Height)
    End Sub

    Private Sub btnCreateXml_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateXml.Click
        Dim xml_document As XmlDocument

        ' Make the XML file.
        xml_document = CreateXmlFile()

        ' Display the document's contents.
        txtContents.Text = XmlDocToString(xml_document)
        txtContents.Select(0, 0)

        ' Save the XML document.
        xml_document.Save(FileStuff.DataSubdirectory() & "\Test.xml")
    End Sub

    ' Make the XML document.
    Private Function CreateXmlFile() As XmlDocument
        Const INDENT As Integer = 4

        Dim xml_document As XmlDocument
        Dim root As XmlElement
        Dim child As XmlElement
        Dim grandchild As XmlElement

        ' Create a new XmlDocument object.
        xml_document = New XmlDocument()
        xml_document.PreserveWhitespace = True

        ' Define the file's version information.
        AddXmlDeclaration(xml_document)
        AddXmlNewLine(xml_document, xml_document, 0)

        ' Associate the XML file with an XSL file.
        AddXmlXSLFile(xml_document, "Test.xsl")

        ' Make the DOCTYPE section.
        AddXmlDocumentType(xml_document, "Root", _
           "<!ENTITY us ""United States of America"">")

        ' Add a blank line before the real data.
        AddXmlNewLine(xml_document, xml_document, 0)

        ' Add a comment.
        AddXmlComment(xml_document, xml_document, _
            "*** The data starts here ***")

        ' Create the root element.
        AddXmlNewLine(xml_document, xml_document, 0)
        root = AddXmlElement(xml_document, xml_document, "Root")

        ' Give the root element some attributes.
        AddXmlAttribute(xml_document, root, "Attr-1", "Value 1")
        AddXmlAttribute(xml_document, root, "Attr-2", "Value 2")

        ' Give the root element some text.
        AddXmlText(xml_document, root, "Root inner text")

        ' Create a child element.
        AddXmlNewLine(xml_document, root, INDENT)
        child = AddXmlElement(xml_document, root, "Child-1")
        AddXmlText(xml_document, child, "Child inner text")
        AddXmlAttribute(xml_document, child, "Child-Attr-1", "Child Value 1")

        ' Create another child element.
        AddXmlNewLine(xml_document, root, INDENT)
        child = AddXmlElement(xml_document, root, "Child-2")

        ' Add some CDATA inside Child 2.
        AddXmlNewLine(xml_document, child, 2 * INDENT)
        AddXmlCdataSection(xml_document, child, vbCrLf & _
            "<Example>" & vbCrLf & _
            "    CDATA text can contain whitespace" & vbCrLf & _
            "    & characters that look like markup!" & vbCrLf & _
            "</Example>")
        AddXmlNewLine(xml_document, child, INDENT)

        ' Create a comment inside the root.
        AddXmlNewLine(xml_document, root, INDENT)
        AddXmlComment(xml_document, root, _
            "The following text and entity reference are in the Root node")

        ' Create a text node inside the root.
        AddXmlNewLine(xml_document, root, INDENT)
        AddXmlText(xml_document, root, "Country = ")

        ' Create an entity reference.
        AddXmlEntityReference(xml_document, root, "us")

        ' Create another child node.
        AddXmlNewLine(xml_document, root, INDENT)
        child = AddXmlElement(xml_document, root, "Child-3")

        ' Create a grandchild.
        AddXmlNewLine(xml_document, child, 2 * INDENT)
        grandchild = AddXmlElement(xml_document, child, "Grandchild-1")

        ' Create a comment inside the grandchild.
        AddXmlNewLine(xml_document, grandchild, 3 * INDENT)
        AddXmlComment(xml_document, grandchild, "This comment is inside Grandchild-1")
        AddXmlNewLine(xml_document, grandchild, 2 * INDENT)
        AddXmlNewLine(xml_document, child, INDENT)

        ' Create a final root-level comment.
        AddXmlNewLine(xml_document, root, 0)
        AddXmlNewLine(xml_document, xml_document, 0)
        AddXmlComment(xml_document, xml_document, "That's all folks!")

        ' Return the document.
        Return xml_document
    End Function
End Class
