<?xml version="1.0"?>
<!--
Note that the first statement in an XSL file has to be the Processing Instruction.

The stylesheet element is the root element of any XSL document, and sets up the namespace so we can use xsl directives.
-->
<xsl:stylesheet version="1.0" 
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--Execute the following code when the parser comes across the root 
    element -->
<xsl:template match="Contacts">
	<html>
       <head>
          <title>Translate Author Information</title>
       </head>
    <body>
	   <b>Translated Author Information</b>
	   <!-- Goto the XSL code that handles all the child elements of
             Author -->
	   <xsl:apply-templates select="Author"/>
	</body>
	</html>
</xsl:template>    
    
    <!-- This is where we process XML for the child elements of Author -->       
	<xsl:template match="Author">
      <p>
       <!-- Set up table to display data -->
	   <table border="1" cellpadding="1" cellspacing="1">
         
         <!-- Titles for each column in the table -->
         <tr><td><b>Element:</b></td>
         <td><b>Attribute:</b></td>
         <td><b>Value:</b></td></tr>
		  <!-- Loop through each child element of Author -->
		  <!-- Note only does one level of child elements.  
               Won't see child elements of the Address Element -->                       		  
	      <xsl:for-each select="child::*">
		     <!-- Display the element's name --> 
		     <tr><td><xsl:value-of select="name()"/><br/></td>  
			 <!-- Display the element's attribute -->
			 <td><xsl:value-of select="@type"/><br/></td>
			 <!-- Display the element's value -->
			 <td><xsl:value-of select="."/><br/></td></tr>
          </xsl:for-each>
	    </table>
    </p>
    </xsl:template>
</xsl:stylesheet>

