Imports System.Runtime.Serialization

' Stores a temperature and returns it in Celsius or Fahrenheit.
<Serializable()> _
Public Class Temperature
    Implements System.Runtime.Serialization.ISerializable

    ' Save the object's serialization information.
    Overridable Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext) _
    Implements System.Runtime.Serialization.ISerializable.GetObjectData
        info.AddValue("Temp", m_TemperatureCelsius)
    End Sub

    ' Constructors.
    Public Sub New()
        m_TemperatureCelsius = 0
    End Sub

    Public Sub New(ByVal temperature_celsius As Double)
        m_TemperatureCelsius = temperature_celsius
    End Sub

    ' Deserialization constructor.
    Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        m_TemperatureCelsius = info.GetDouble("Temp")
    End Sub

    ' Store the temperature in degrees Celsius.
    Private m_TemperatureCelsius As Double

    ' Get/set the temperature in degrees Fahrenheit.
    Public Property TemperatureFahrenheit() As Double
        Get
            TemperatureFahrenheit = m_TemperatureCelsius * 9 / 5 + 32
        End Get
        Set(ByVal Value As Double)
            m_TemperatureCelsius = (Value - 32) / 9 * 5
        End Set
    End Property

    ' Get/set the temperature in degrees Celsius.
    Public Property TemperatureCelsius() As Double
        Get
            TemperatureCelsius = m_TemperatureCelsius
        End Get
        Set(ByVal Value As Double)
            m_TemperatureCelsius = Value
        End Set
    End Property
End Class
