Imports MSXML2

Public Class SAXErrorEvents
    Implements IVBSAXErrorHandler

    ' Events we reraise for the main program.
    Public Event SAXIgnoreableWarning( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer)
    Public Event SAXError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer)
    Public Event SAXFatalError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer)

        ' This method is called when the SAX reader encounters
        ' an igorable warning. 
        '
        ' Note: SAX2 doesn't call this method.
    Overridable Sub CatchIgnorableWarning( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer) _
    Implements IVBSAXErrorHandler.ignorableWarning
        RaiseEvent SAXIgnoreableWarning( _
            oLocator, _
            strErrorMessage, _
            nErrorCode)
    End Sub

    ' This method is called when the SAX reader encounters 
    ' a non-fatal error.
    '
    ' Note: SAX2 doesn't call this method.
    Overridable Sub CatchError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer) _
    Implements IVBSAXErrorHandler.error
        RaiseEvent SAXError( _
            oLocator, _
            strErrorMessage, _
            nErrorCode)
    End Sub

    ' This method is called when the SAX reader encounters 
    ' a fatal error.
    Overridable Sub CatchFatalError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer) _
    Implements IVBSAXErrorHandler.fatalError
        RaiseEvent SAXFatalError( _
            oLocator, _
            strErrorMessage, _
            nErrorCode)
    End Sub
End Class
