Imports MSXML2

Public Class OrderErrorHandler
    Implements IVBSAXErrorHandler

    ' When our error method is called, we raise this error.
    Public Event OrderError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer)

    ' This method is called when the SAX reader encounters
    ' an igorable warning. 
    '
    ' Note: SAX2 doesn't call this method.
    Overridable Sub CatchIgnorableWarning( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer) _
    Implements IVBSAXErrorHandler.ignorableWarning

    End Sub

    ' This method is called when the SAX reader encounters 
    ' a non-fatal error.
    '
    ' Note: SAX2 doesn't call this method.
    Overridable Sub CatchError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer) _
    Implements IVBSAXErrorHandler.error

    End Sub

    ' This method is called when the SAX reader encounters 
    ' a fatal error.
    Overridable Sub CatchFatalError( _
        ByVal oLocator As MSXML2.IVBSAXLocator, _
        ByRef strErrorMessage As String, _
        ByVal nErrorCode As Integer) _
    Implements IVBSAXErrorHandler.fatalError
        RaiseEvent OrderError(oLocator, strErrorMessage, nErrorCode)
    End Sub
End Class
