<%@ Page Language="VB" %>
<%@ Import Namespace="System.Xml" %>

<!-- Author data island. -->
<!-- Note that including an XML declaration confuses LoadXml. -->
<XML ID="xmlAuthors" RUNAT="Server">
  <Authors>
    <Author>
      <FirstName>Rod</FirstName>
      <LastName>Stephens</LastName>
      <EmailAddress>RodStephens@vb-helper.com</EmailAddress>
      <HomePageName>VB Helper</HomePageName>
      <HomePageURL>http://www.vb-helper.com</HomePageURL>
      <Image>./rod.jpg</Image>
    </Author>
    <Author>
      <FirstName>Brian</FirstName>
      <LastName>Hochgurtel</LastName>
      <EmailAddress>brian@advocatemedia.com</EmailAddress>
      <HomePageName>Advocate Media</HomePageName>
      <HomePageURL>http://www.advocatemedia.com</HomePageURL>
      <Image>./brian.jpg</Image>
    </Author>
  </Authors>
</XML>

<!-- Create the subroutine that builds the table's rows. -->
<SCRIPT Language="VB" RUNAT="Server">
Sub BuildRows()
    Dim xml_doc As New XmlDocument()
    Dim row_node As XmlNode
    Dim field_node As XmlNode
    Dim home_page_url_node As XmlNode
    Dim row_name As String

    xml_doc.LoadXml(xmlAuthors.InnerHTML)
    For Each row_node In xml_doc.DocumentElement.ChildNodes
        ' Send data to the Response object using the Write method.
        ' Write out the beginning table row tag.
        Response.Write("<TR>")

        ' Begin a table cell.
        Response.Write("<TD>")

        ' Write the value of FirstName.
        field_node = row_node.SelectSingleNode("FirstName")
        If Not (field_node Is Nothing) Then _
          row_name = field_node.InnerXml

        ' Write the value of LastName and close the cell.
        field_node = row_node.SelectSingleNode("LastName")
        If Not (field_node Is Nothing) Then _
          row_name = row_name & " " & field_node.InnerXml
        Response.Write(row_name)
        Response.Write("</TD>")

        ' Create the Email link.
        Response.Write("<TD>")
        field_node = row_node.SelectSingleNode("EmailAddress")
        If Not (field_node Is Nothing) Then Response.Write( _
          "<A HREF=""mailto:" & field_node.InnerXml & """>" & _
          field_node.InnerXml & "</A>")
        Response.Write("</TD>")

        ' Create the link to each author's home page.
        Response.Write("<TD>")
        field_node = row_node.SelectSingleNode("HomePageName")
        If Not (field_node Is Nothing) Then
          home_page_url_node = row_node.SelectSingleNode("HomePageURL")
          If Not (home_page_url_node Is Nothing) Then
            Response.Write( _
              "<A HREF=""" & home_page_url_node.InnerXml & """>" & _
              field_node.InnerXml & "</A>")
          End If
        End If
        Response.Write("</TD>")

        ' Display the Image.
        Response.Write("<TD>")
        field_node = row_node.SelectSingleNode("Image")
        If Not (field_node Is Nothing) Then Response.Write( _
          "<IMG SRC=""" & field_node.InnerXml & """></IMG>")
        Response.Write("</TD>")

        Response.Write("</TR>")
    Next row_node
End Sub
</SCRIPT>

<!-- HTML Code. -->
<HTML>
    <HEAD>
        <TITLE>Authors</TITLE>
    </HEAD>

    <BODY>
        <H1><CENTER>Authors</CENTER></H1>

        <!-- Create the table. -->
        <TABLE BORDER="1" BGCOLOR="#E0E0E0" CELLPADDING="5">
            <THEAD>
                <TH>Name</TH>
                <TH>Email Address</TH>
                <TH>Home Page</TH>
                <TH>Image</TH>
            </THEAD>

            <!-- Call BuildRows to make the table's rows. -->
            <% BuildRows() %>
        </TABLE>
    </BODY>
</HTML>
