<xsl:stylesheet version="1.1" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!-- The statement above sets up this document as an XSL file 
     with the appropriate namespace. -->

<!-- This next statement executes for all parts of the XML document. -->
  <xsl:template match="/">
    <!-- Note there is HTML here. It must be well-formed meaning
         every opening HTML tag must have a closing tag. -->
    <html>
      <head>
        <title>Author Information</title>
      </head>
      <body>
        <h1>Author Information</h1>
        <!-- Display results in a table. -->
        <table border="1">
          <!-- Start moving through the document. -->
          <xsl:apply-templates/>
        </table>
      </body>
    </html>
  </xsl:template>

  <!-- Execute the following code for each Author element. -->
  <xsl:template match="Author">
    <!-- Loop through each child of the Author element. This includes
         IMG, FirstName, LastName, etc. -->
    <xsl:for-each select="child::*">
      <tr>
      <!-- Display the name of the current element. -->
        <td><xsl:value-of select="name()"/>
        <!-- Loop through each attribute of the concurrent 
             node (the node XSLT is currently considering). -->
          <xsl:for-each select="attribute::*">
            <!-- Note that the line break is treated as an 
                 empty element. It's an error not to. -->
            <br/>
            <!-- Display names and values of each attribue. -->
            <xsl:value-of select="name()"/>=
            <font color="red">
              <xsl:value-of select="."/>
            </font>
          </xsl:for-each> 
        </td>
        <td><xsl:value-of select="."/></td>
      </tr>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
