<xsl:stylesheet version="1.1"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" omit-xml-declaration="yes" indent="yes"/>
<xsl:strip-space elements="*"/>

  <!-- Root. -->
  <xsl:template match="/">
    <!-- Begin the VoiceXML application. -->
    <vxml application="http://resources.tellme.com/lib/universals.vxml">

      <!-- Begin Scope of VXML application. -->
      <meta name="scoping" content="new" />

      <!-- All the action of a Voice XML application
           occurs within form tags. -->
      <form id="Read Web Page Info">
        <!-- A VXML app may have several blocks where code executes. -->
        <block>
          <!-- Process the other nodes. -->
          <xsl:apply-templates/>
        </block>
      </form>
    </vxml>
  </xsl:template>

  <!-- Title. -->
  <xsl:template match="//Title">
    <xsl:comment>Read the title.</xsl:comment>

    <!-- The audio tag tells the voice app to begin reading.-->
    <audio>
      The title of this XML document is:
    </audio>

    <!-- Pause briefly between reading things. -->
    <pause>100</pause>

    <audio>
      <xsl:value-of select="."/>
    </audio>

    <pause>1000</pause>
  </xsl:template>

  <!-- Heading. -->
  <xsl:template match="//Heading">
    <xsl:comment>Read the heading.</xsl:comment>
    <audio>
      The heading of this XML document is:
    </audio>
    <pause>100</pause>
    <audio>
      <xsl:value-of select="."/>
    </audio>
    <pause>1000</pause>
  </xsl:template>

  <!-- BodyText. -->
  <xsl:template match="//BodyText">
    <xsl:comment>Read the body text.</xsl:comment>
    <audio>
      The text of this XML document includes:
    </audio>
    <pause>100</pause>
    <audio>
      <xsl:value-of select="."/>
    </audio>
    <pause>1000</pause>
  </xsl:template>
</xsl:stylesheet>
