Attribute VB_Name = "NewMacros"
' Remove leading and trailing invisible characters from the string.
Private Function StripWhitespace(ByVal txt As String) As String
    Dim ch As String
    Dim pos1 As Integer
    Dim pos2 As Integer

    ' Find the first non-whitespace character.
    For pos1 = 1 To Len(txt)
        ch = Mid$(txt, pos1, 1)
        If ch > " " And ch <= "~" Then Exit For
    Next pos1

    ' Find the first non-whitespace character.
    For pos2 = Len(txt) To pos1 Step -1
        ch = Mid$(txt, pos2, 1)
        If ch > " " And ch <= "~" Then Exit For
    Next pos2

    ' Return the text between pos1 and pos2, inclusive.
    If pos1 > pos2 Then
        StripWhitespace = ""
    Else
        StripWhitespace = Mid$(txt, pos1, pos2 - pos1 + 1)
    End If
End Function
' Load the data in the XML document into a Word table
' in the currently active spreadsheet.
Sub LoadXmlTable(ByVal xml_file_name As String)
Attribute LoadXmlTable.VB_Description = "Macro recorded 8/22/2001 by Rod"
Attribute LoadXmlTable.VB_ProcData.VB_Invoke_Func = "Normal.NewMacros.MakeTable"
    Dim dom_document As DOMDocument
    Dim table_node As IXMLDOMNode
    Dim row_node As IXMLDOMNode
    Dim column_node As IXMLDOMNode
    Dim r As Integer
    Dim c As Integer
    Dim origin_row As Integer
    Dim origin_col As Integer

    ' Load the XML file into a DOM representation.
    Set dom_document = New DOMDocument
    dom_document.Load xml_file_name

    ' Get the Books node.
    Set table_node = dom_document.documentElement

    ' Find the current cell's location in the workbook.
    origin_row = ActiveCell.Row
    origin_col = ActiveCell.Column

    ' Enter the data into the active workbook.
    r = 0
    For Each row_node In table_node.childNodes
        c = 0
        For Each column_node In row_node.childNodes
            ActiveSheet.Cells(origin_row + r, origin_col + c) = column_node.Text
            c = c + 1
        Next column_node
        r = r + 1
    Next row_node

    ' Autofit the new cells.
    ActiveSheet.Range( _
        ActiveSheet.Cells(origin_row, origin_col).Address & ":" & _
        ActiveSheet.Cells(origin_row + r - 1, origin_col + c - 1).Address).Select
    ActiveSheet
'    heet.Cells(origin_row + r - 1, origin_col + c - 1).Address).Columns.AutoFit
End Sub
Sub TestLoadXmlTable()
    LoadXmlTable "C:\VB XML\Src\Ch10\XmlExcel\Data\Table.xml"
End Sub
' Save the currently selected table in an XML file.
Sub SaveXmlTable(ByVal xml_file_name As String)
    Dim word_table As Table
    Dim dom_document As DOMDocument
    Dim processing_instruction As IXMLDOMProcessingInstruction
    Dim table_element As IXMLDOMElement
    Dim row_element As IXMLDOMElement
    Dim cell_element As IXMLDOMElement
    Dim r As Integer
    Dim c As Integer

    ' Create the new DOM document.
    Set dom_document = New DOMDocument
    Set processing_instruction = dom_document.createProcessingInstruction("xml", "version='1.0'")
    dom_document.appendChild processing_instruction

    ' Find the table.
    Set word_table = Selection.Tables.Item(1)

    ' Write the Books element.
    Set table_element = dom_document.createElement("Books")
    dom_document.appendChild table_element

    ' Write the rows.
    For r = 1 To word_table.Rows.Count
        ' Indent.
        table_element.appendChild dom_document.createTextNode(vbCrLf & "  ")

        ' Create the Book element.
        Set row_element = dom_document.createElement("Book")
        table_element.appendChild row_element

        ' Write this row's columns.
        For c = 1 To word_table.Columns.Count
            ' Indent.
            row_element.appendChild dom_document.createTextNode(vbCrLf & "    ")

            ' Create the BookInfo element.
            Set cell_element = dom_document.createElement("BookInfo")
            row_element.appendChild cell_element

            ' Add the cell's text.
            cell_element.appendChild dom_document.createTextNode(StripWhitespace(word_table.Cell(r, c).Range.Text))
        Next c

        ' Indent before the </Book> tag.
        row_element.appendChild dom_document.createTextNode(vbCrLf & "  ")
    Next r

    ' New line before the </Books> tag.
    table_element.appendChild dom_document.createTextNode(vbCrLf)

    ' Save the DOM document.
    dom_document.Save xml_file_name
    Set dom_document = Nothing
End Sub
Sub TestSaveXmlTable()
    SaveXmlTable "C:\VB XML\Src\Ch10\XmlExcel\Data\Table.xml"
End Sub
