Attribute VB_Name = "Module1"
' Import the address information from this XML file.
Sub ImportAddresses(ByVal xml_file As String)
Dim dom_document As DOMDocument
Dim root_node As IXMLDOMNode
Dim entry_node As IXMLDOMNode
Dim field_node As IXMLDOMNode
Dim contact_item As Outlook.ContactItem

    ' Load the XML file.
    Set dom_document = New DOMDocument
    dom_document.Load xml_file

    ' Loop through the Entry elements.
    Set root_node = dom_document.documentElement
    For Each entry_node In root_node.childNodes
        ' Create a new address book entry.
        Set contact_item = Outlook.CreateItem(olContactItem)

        ' Loop through the field elements.
        For Each field_node In entry_node.childNodes
            ' See which field this is.
            Select Case field_node.nodeName
                Case "LastName"
                    contact_item.LastName = field_node.Text
                Case "FirstName"
                    contact_item.FirstName = field_node.Text
                Case "HomePage"
                    contact_item.WebPage = field_node.Text
                Case "EmailAddress"
                    contact_item.Email1Address = field_node.Text
            End Select
        Next field_node

        ' Save the contact information.
        contact_item.Save
    Next entry_node
End Sub
' Import addresses from Addresses.xml.
Sub TestImportAddresses()
    ImportAddresses "C:\VB XML\Src\Ch10\XmlOutlook\Addresses.xml"
End Sub
